/*************************************************
 **                                             **
 **   ntx.h                                     **
 **                                             **
 **          Copyright (C) 1990-1992 by         **
 **               SoftC, Ltd.                   **
 **               16820 3rd St NE               **
 **               Anoka, MN 55304               **
 **               (612) 434-6968                **
 **                                             **
 **             All rights reserved.            **
 *************************************************/



#ifndef __SOFTC_H__
#include "softc.h"
#endif



/**********
 *
 *  Type Definitions
 *
 **********/




typedef struct {  /* Clipper index file information packet */
  CHAR fname[80]; /* file name */
  SC_FLAGS flags; /* miscellaneous flags */
  INT keylen;     /* key length */
  INT keytype;    /* key type */
  INT keyfmt;     /* unique, descending, etc. */
  INT keydpl;     /* number of decimal places in numeric keys */
  INT lockt;      /* file lock/unlock flag */
  INT exprlen;    /* key expression length */
  CHAR expr[100]; /* first 100 characters of index expression */
} SC_NTXINFO;






#ifdef __ANSI_PROTOTYPES__
#ifdef __cplusplus
extern "C" {
#endif


/**********
 *
 *  Clipper Index File Manipulators Prototypes
 *
 **********/




INT PROTOS scdcbfrsz(  INT,              /* index file handle */
		       INT F_PTR,        /* buffer length in pages */
		       INT );            /* set or get buffer length */

INT PROTOS scdcclose(  INT );            /* file handle */

INT PROTOS scdccreate( CHAR F_PTR,       /* filename */
		       INT,              /* index key type */
		       CHAR F_PTR,       /* key expression */
		       INT,              /* key length */
		       INT );            /* number of decimal places */

INT PROTOS scdcexpr(   INT,              /* file handle */
		       CHAR F_PTR );     /* key expression */

INT PROTOS scdcflush(  INT );            /* file handle */

INT PROTOS scdchget(   INT );            /* file handle */

INT PROTOS scdcindex(  INT,              /* data file handle */
		       CHAR F_PTR,       /* new file name */
		       INT,              /* index key type */
		       CHAR F_PTR,       /* key expression */
		       INT,              /* key length */
		       INT );            /* number of decimal places */

INT PROTOS scdcinfo(   INT,              /* file handle */
		       SC_NTXINFO F_PTR ); /* file information and status */

INT PROTOS scdclock(   INT );            /* file handle */

INT PROTOS scdcopenx(  INT F_PTR,        /* file handle */
		       CHAR F_PTR,       /* filename */
		       INT );            /* open mode and characteristics */

INT PROTOS scdcunlock( INT );            /* file handle */




/**********
 *
 *  Clipper Index Key Building Prototypes
 *
 **********/




INT PROTOS scdckdate(  CHAR F_PTR,       /* new key value */
		       CHAR F_PTR,       /* source date string */
		       INT );            /* date string format */

INT PROTOS scdckmake(  INT,              /* .DBF file handle */
		       INT,              /* .NTX file handle */
		       VOID F_PTR F_PTR ); /* index key */

INT PROTOS scdcknum(   INT,              /* index file handle */
		       CHAR F_PTR,       /* new key value */
		       DOUBLE );         /* source number */




/**********
 *
 *  Clipper Index Key Manipulator Prototypes
 *
 **********/




INT PROTOS scdckadd(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG );           /* data record number */

INT PROTOS scdckbot(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */

INT PROTOS scdckcur(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */

INT PROTOS scdckdel(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG );           /* data record number */

INT PROTOS scdckfind(  INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR,       /* data record number */
		       INT);             /* exact match or first */

INT PROTOS scdcknext(  INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */

INT PROTOS scdckprev(  INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */

INT PROTOS scdcktop(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */


#ifdef __cplusplus
}
#endif
#endif

